/*
scotty-rev - Scotty REVOLUTION Network Management Dashboard

Authors:
  Thomas Liske <liske@ibh.de>

Copyright Holder:
  2012 - 2013 (C) Thomas Liske [https://fiasko-nw.net/~thomas/tag/scotty]
  2014 - 2016 (C) IBH IT-Service GmbH [http://www.ibh.de/OSS/Scotty]

License:
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this package; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
*/

/*jslint
    devel: true
*/

if (typeof BCP === "undefined") {
    BCP = {};
}
if (typeof BCP.Core === "undefined") {
    BCP.Core = {};
}

(function ($) {
    "use strict";

    var version = '0.1';

    this.bcpVersion = function () {
        return version;
    };

    this.bcpConfigLoaded = function (json) {
        this.config = json;

        /* MQTT defaults */
        if (typeof this.config.mqttws_host === "undefined") {
            this.config.mqttws_host = window.location.hostname;
        }
        if (typeof this.config.mqttws_port === "undefined") {
            this.config.mqttws_port = 9001;
        }

        BCP.MQTT.bcpInit(this.config.mqttws_host, this.config.mqttws_port);
    };
    
    this.bcpConfigLoad = function (configURI, failfn) {
        console.debug('Loading ' + configURI);

        $.ajax({
            'global': false,
            'url': configURI + '?nonce=' + Math.random(),
            'dataType': 'json',
            'success': this.bcpConfigLoaded.bind(this),
            'error': (function () {
                /* MQTT defaults */
                this.config.mqttws_host = window.location.hostname;
                this.config.mqttws_port = 9001;

                BCP.MQTT.bcpInit(this.config.mqttws_host, this.config.mqttws_port);
            }).bind(this)
        });
    };
    
    this.bcpInit = function () {
        console.info('Initializing Barkery Control Panel ' + version);

        BCP.Terminals.bcpInit();
        this.bcpConfigLoad('config.json', function (jqXHR, textStatus, errorThrown) {
            console.error('Failed to load configuration: ' + textStatus + ' - ' + errorThrown);
        });
    };
}).call(BCP.Core, jQuery);
